Loading...
Searching...
No Matches
EST_Regex Class Reference

`#include <include/EST_Regex.h>`

Inheritance diagram for EST_Regex:
[legend]
Collaboration diagram for EST_Regex:
[legend]

## Public Member Functions

| EST_Regex (void)
| Empty constructor, just for form.
| EST_Regex (EST_String s)
| Construct from EST_String.
| EST_Regex (const char *ex)
| Construct from C string.
| EST_Regex (const EST_Regex &ex)
| Copy constructor.
| ~EST_Regex ()
| Destructor.
int | size () const
| Size of the expression.
int | run (const char *on, int from, int &start, int &end, int *starts=NULL, int *ends=NULL)
| Run to find a matching substring.
int | run_match (const char *on, int from=0, int *starts=NULL, int *ends=NULL)
| Run to see if it matches the entire string.
EST_String | tostring (void) const
| Get the expression as a string.
| operator const char * () const
| Cast operator, disambiguates it for some compilers.
int | operator== (const EST_Regex ex) const
int | operator!= (const EST_Regex ex) const

## Protected Member Functions

void | compile ()
| Compile expression.
void | compile_match ()
| Compile expression in a form which only matches whole string.
char * | regularize (int match) const
| Translate the expression into the internally used syntax.
Protected Member Functions inherited from EST_String
EST_String | before (int pos, int len=0) const
| Part before position.
EST_String | before (const char *s, int pos=0) const
| Part before first matching substring after pos.
EST_String | before (const EST_String &s, int pos=0) const
| Part before first matching substring after pos.
EST_String | before (EST_Regex &e, int pos=0) const
| Part before first match of regexp after pos.
EST_String | at (int from, int len=0) const
| Return part at position.
EST_String | at (const char *s, int pos=0) const
| Return part where substring found (not useful, included for completeness).
EST_String | at (const EST_String &s, int pos=0) const
| Return part where substring found (not useful, included for completeness).
EST_String | at (EST_Regex &e, int pos=0) const
| Return part matching regexp.
EST_String | after (int pos, int len=1) const
| Part after pos+len.
EST_String | after (const char *s, int pos=0) const
| Part after substring.
EST_String | after (const EST_String &s, int pos=0) const
| Part after substring.
EST_String | after (EST_Regex &e, int pos=0) const
| Part after match of regular expression.
int | search (const char *s, int len, int &mlen, int pos=0) const
| Find a substring.
int | search (const EST_String s, int &mlen, int pos=0) const
| Find a substring.
int | search (EST_Regex &re, int &mlen, int pos=0, int *starts=NULL, int *ends=NULL) const
| Find a match of the regular expression.
int | index (const char *s, int pos=0) const
| Position of substring (starting at pos).
int | index (const EST_String &s, int pos=0) const
| Position of substring (starting at pos).
int | index (EST_Regex &ex, int pos=0) const
| Position of match of regexp (starting at pos).
int | contains (const char *s, int pos=-1) const
| Does it contain this substring?
int | contains (const EST_String &s, int pos=-1) const
| Does it contain this substring?
int | contains (const char c, int pos=-1) const
| Does it contain this character?
int | contains (EST_Regex &ex, int pos=-1) const
| Does it contain a match for this regular expression?
int | matches (const char *e, int pos=0) const
| Exactly match this string?
int | matches (const EST_String &e, int pos=0) const
| Exactly match this string?
int | matches (EST_Regex &e, int pos=0, int *starts=NULL, int *ends=NULL) const
| Exactly matches this regular expression, can return ends of sub-expressions.
int | gsub (const char *os, const EST_String &s)
| Substitute one string for another.
int | gsub (const char *os, const char *s)
| Substitute one string for another.
int | gsub (const EST_String &os, const EST_String &s)
| Substitute one string for another.
int | gsub (const EST_String &os, const char *s)
| Substitute one string for another.
int | gsub (EST_Regex &ex, const EST_String &s)
| Substitute string for matches of regular expression.
int | gsub (EST_Regex &ex, const char *s)
| Substitute string for matches of regular expression.
int | gsub (EST_Regex &ex, int bracket_num)
| Substitute string for matches of regular expression.
int | subst (EST_String source, int(&starts)[EST_Regex_max_subexpressions], int(&ends)[EST_Regex_max_subexpressions])
| Substitute the result of a match into a string.
int | freq (const char *s) const
| Number of occurrences of substring.
int | freq (const EST_String &s) const
| Number of occurrences of substring.
int | freq (EST_Regex &s) const
| Number of matches of regular expression.
EST_String | quote (const char quotec) const
| Return the string in quotes with internal quotes protected.
EST_String | quote_if_needed (const char quotec) const
| Return in quotes if there is something to protect (e.g. spaces).
EST_String | unquote (const char quotec) const
| Remove quotes and unprotect internal quotes.
EST_String | unquote_if_needed (const char quotec) const
| Remove quotes if any.
const char | operator() (int i) const
| Function style access to constant strings.
char & | operator[] (int i)
| Array style access to writable strings.
| operator const char * () const
| Cast to const char * by simply giving access to pointer.
| operator const char * ()
| operator char * ()
| Cast to char *, may involve copying.
EST_String & | operator+= (const char *b)
| Add C string to end of EST_String.
EST_String & | operator+= (const EST_String b)
| Add EST_String to end of EST_String.
EST_String & | operator= (const char *str)
| Assign C string to EST_String.
EST_String & | ignore_volatile (void) volatile
| EST_String (void)
| Construct an empty string.
| EST_String (const char *s)
| Construct from char *.
| EST_String (const char *s, int start_or_fill, int len)
| Construct from part of char * or fill with given character.
| EST_String (const char *s, int s_size, int start, int len)
| Construct from C string.
| EST_String (const EST_String &s, int start, int len)
| ~EST_String ()
| Destructor.
int | length (void) const
| Length of string ({not} length of underlying chunk).
int | space (void) const
| Size of underlying chunk.
const char * | str (void) const
| Get a const-pointer to the actual memory.
char * | updatable_str (void)
| Get a writable pointer to the actual memory.
void | make_updatable (void)
int | Int (bool &ok) const
| Convert to an integer.
int | Int (void) const
long | Long (bool &ok) const
| Convert to a long.
long | Long (void) const
float | Float (bool &ok) const
| Convert to a float.
float | Float (void) const
double | Double (bool &ok) const
| Convert to a double.
double | Double (void) const

## Assignment

EST_Regex & | operator= (const EST_Regex ex)
EST_Regex & | operator= (const EST_String s)
EST_Regex & | operator= (const char *s)
ostream & | operator<< (ostream &s, const EST_Regex &str)
| Stream output of regular expression.

## Additional Inherited Members

Protected Types inherited from EST_String
typedef int | EST_string_size
| Type of string size field.
static EST_String | cat (const EST_String s1, const EST_String s2=Empty, const EST_String s3=Empty, const EST_String s4=Empty, const EST_String s5=Empty, const EST_String s6=Empty, const EST_String s7=Empty, const EST_String s8=Empty, const EST_String s9=Empty)
static EST_String | FromChar (const char c)
| Build string from a single character.
static EST_String | Number (int i, int base=10)
| Build string from an integer.
static EST_String | Number (long i, int base=10)
| Build string from a long integer.
static EST_String | Number (double d)
| Build string from a double.
static EST_String | Number (float f)
| Build string from a float.
Static Protected Attributes inherited from EST_String
static const char * | version = "CSTR String Class " STRING_VERSION " " STRING_DATE
| Global version string.
static const EST_String | Empty
| Constant empty string.

## Detailed Description

A Regular expression class to go with the CSTR EST_String class.

The regular expression syntax is the FSF syntax used in emacs and in the FSF String library. This is translated into the syntax supported by Henry Spensor's regular expression library, this translation is a place to look if you find regular expressions not matching where expected.

See also
  EST_String
  string_example

Author
  Richard Caley rjc@c.nosp@m.str..nosp@m.ed.ac.nosp@m..uk
  (regular expression library by Henry Spencer, University of Toronto)

Version

Id
  EST_Regex.h,v 1.3 2004/05/04 00:00:16 awb Exp

Definition at line 55 of file EST_Regex.h.

## Constructor & Destructor Documentation

## EST_Regex() [1/4]

EST_Regex::EST_Regex | ( | void |  | ) |

Empty constructor, just for form.

Definition at line 111 of file EST_Regex.cc.

## EST_Regex() [2/4]

EST_Regex::EST_Regex | ( | EST_String | s | ) |

Construct from EST_String.

Definition at line 126 of file EST_Regex.cc.

## EST_Regex() [3/4]

EST_Regex::EST_Regex | ( | const char * | ex | ) |

Construct from C string.

Definition at line 117 of file EST_Regex.cc.

## EST_Regex() [4/4]

EST_Regex::EST_Regex | ( | const EST_Regex & | ex | ) |

Copy constructor.

Definition at line 133 of file EST_Regex.cc.

## ~EST_Regex()

EST_Regex::~EST_Regex | ( |  | ) |

Destructor.

Definition at line 140 of file EST_Regex.cc.

## Member Function Documentation

## compile()

void EST_Regex::compile | ( |  | ) |

protected

Compile expression.

Definition at line 213 of file EST_Regex.cc.

## compile_match()

void EST_Regex::compile_match | ( |  | ) |

protected

Compile expression in a form which only matches whole string.

Definition at line 227 of file EST_Regex.cc.

## regularize()

char * EST_Regex::regularize | ( | int | match | ) | const

protected

Translate the expression into the internally used syntax.

Definition at line 152 of file EST_Regex.cc.

## size()

int EST_Regex::size | ( |  | ) | const

inline

Size of the expression.

Definition at line 88 of file EST_Regex.h.

## run()

int EST_Regex::run | ( | const char * | on,
|  | int | from,
|  | int & | start,
|  | int & | end,
|  | int * | starts = NULL,
|  | int * | ends = NULL )

Run to find a matching substring.

Definition at line 242 of file EST_Regex.cc.

## run_match()

int EST_Regex::run_match | ( | const char * | on,
|  | int | from = 0,
|  | int * | starts = NULL,
|  | int * | ends = NULL )

Run to see if it matches the entire string.

Definition at line 275 of file EST_Regex.cc.

## tostring()

EST_String EST_Regex::tostring | ( | void |  | ) | const

inline

Get the expression as a string.

Definition at line 96 of file EST_Regex.h.

## operator const char *()

EST_Regex::operator const char * | ( |  | ) | const

inline

Cast operator, disambiguates it for some compilers.

Definition at line 99 of file EST_Regex.h.

## operator==()

int EST_Regex::operator== | ( | const EST_Regex | ex | ) | const

inline

Definition at line 101 of file EST_Regex.h.

## operator!=()

int EST_Regex::operator!= | ( | const EST_Regex | ex | ) | const

inline

Definition at line 104 of file EST_Regex.h.

## operator=() [1/3]

EST_Regex & EST_Regex::operator= | ( | const EST_Regex | ex | ) |

Definition at line 303 of file EST_Regex.cc.

## operator=() [2/3]

EST_Regex & EST_Regex::operator= | ( | const EST_String | s | ) |

Definition at line 312 of file EST_Regex.cc.

## operator=() [3/3]

EST_Regex & EST_Regex::operator= | ( | const char * | s | ) |

Definition at line 321 of file EST_Regex.cc.

## Friends And Related Symbol Documentation

## operator<<

ostream & operator<< | ( | ostream & | s,
|  | const EST_Regex & | str )

friend

Stream output of regular expression.

Definition at line 330 of file EST_Regex.cc.

The documentation for this class was generated from the following files:

- include/EST_Regex.h
- base_class/string/EST_Regex.cc